package techreborn.client.render.parts;

import net.minecraft.client.renderer.block.model.ModelResourceLocation;
import net.minecraft.util.ResourceLocation;
import net.minecraftforge.client.event.ModelBakeEvent;
import net.minecraftforge.client.event.TextureStitchEvent;
import net.minecraftforge.fml.common.eventhandler.EventPriority;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import techreborn.parts.fluidPipes.EnumFluidPipeTypes;
import techreborn.parts.powerCables.EnumCableType;

/**
 * Created by modmuss50 on 04/03/2016.
 */
public class ClientPartModelBakery
{

	@SideOnly(Side.CLIENT)
	@SubscribeEvent(priority = EventPriority.LOWEST)
	public void onModelBake(ModelBakeEvent event)
	{
		for (EnumCableType type : EnumCableType.values())
		{
			event.getModelRegistry().func_82595_a(
					new ModelResourceLocation("techreborn:cable#type=" + type.func_176610_l().toLowerCase()),
					new RenderCablePart(type));
		}
		for(EnumFluidPipeTypes type : EnumFluidPipeTypes.values()){
			event.getModelRegistry().func_82595_a(
					new ModelResourceLocation("techreborn:fluidpipe#type=" + type.func_176610_l().toLowerCase()),
					new RenderFluidPipePart(type));
		}

	}

	@SubscribeEvent
	public void textureStichEvent(TextureStitchEvent event)
	{
		for (EnumCableType type : EnumCableType.values())
		{
			event.getMap().func_174942_a(new ResourceLocation(type.textureName));
		}
		for(EnumFluidPipeTypes type : EnumFluidPipeTypes.values()){
			event.getMap().func_174942_a(new ResourceLocation(type.textureName));
		}
	}

}
