package techreborn.items;

import java.security.InvalidParameterException;
import java.util.List;

import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import techreborn.client.TechRebornCreativeTabMisc;
import techreborn.init.ModItems;
import techreborn.lib.ModInfo;

public class ItemGems extends ItemTextureBase
{

	public static final String[] types = new String[] { "ruby", "sapphire", "peridot", "redGarnet", "yellowGarnet" };

	public ItemGems()
	{
		func_77637_a(TechRebornCreativeTabMisc.instance);
		func_77655_b("techreborn.gem");
		func_77627_a(true);
	}

	public static ItemStack getGemByName(String name, int count)
	{
		for (int i = 0; i < types.length; i++)
		{
			if (types[i].equalsIgnoreCase(name))
			{
				return new ItemStack(ModItems.gems, count, i);
			}
		}
		throw new InvalidParameterException("The gem " + name + " could not be found.");
	}

	public static ItemStack getGemByName(String name)
	{
		return getGemByName(name, 1);
	}

	@Override
	// gets Unlocalized Name depending on meta data
	public String func_77667_c(ItemStack itemStack)
	{
		int meta = itemStack.func_77952_i();
		if (meta < 0 || meta >= types.length)
		{
			meta = 0;
		}

		return super.func_77658_a() + "." + types[meta];
	}

	// Adds Dusts SubItems To Creative Tab
	public void func_150895_a(Item item, CreativeTabs creativeTabs, List list)
	{
		for (int meta = 0; meta < types.length; ++meta)
		{
			list.add(new ItemStack(item, 1, meta));
		}
	}

	@Override
	public String getTextureName(int damage)
	{
		return ModInfo.MOD_ID + ":items/gem/" + types[damage];
	}

	@Override
	public int getMaxMeta()
	{
		return types.length;
	}

}
