package techreborn.tiles;

import net.minecraft.block.Block;
import net.minecraft.block.material.Material;
import net.minecraft.block.state.IBlockState;
import net.minecraft.init.Blocks;
import net.minecraft.init.Items;
import net.minecraft.item.*;
import net.minecraft.item.crafting.FurnaceRecipes;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.nbt.NBTTagList;
import net.minecraft.tileentity.TileEntityFurnace;
import net.minecraftforge.fml.common.registry.GameRegistry;
import reborncore.api.tile.IInventoryProvider;
import reborncore.common.blocks.BlockMachineBase;
import reborncore.common.tile.TileMachineBase;
import reborncore.common.util.Inventory;

public class TileIronFurnace extends TileMachineBase implements IInventoryProvider
{

	public int tickTime;
	public Inventory inventory = new Inventory(3, "TileIronFurnace", 64, this);
	public int fuel;
	public int fuelGague;
	public int progress;
	public int fuelScale = 200;
	int input1 = 0;
	int output = 1;
	int fuelslot = 2;
	boolean active = false;

	public int gaugeProgressScaled(int scale)
	{
		return (progress * scale) / fuelScale;
	}

	public int gaugeFuelScaled(int scale)
	{
		if (fuelGague == 0)
		{
			fuelGague = fuel;
			if (fuelGague == 0)
			{
				fuelGague = fuelScale;
			}
		}
		return (fuel * scale) / fuelGague;
	}

	@Override
	public void updateEntity()
	{
		boolean burning = isBurning();
		boolean updateInventory = false;
		if (fuel > 0)
		{
			fuel--;
			updateState();
		}
		if (fuel <= 0 && canSmelt())
		{
			fuel = fuelGague = (int) (TileEntityFurnace.func_145952_a(func_70301_a(fuelslot)) * 1.25);
			if (fuel > 0)
			{
				if (func_70301_a(fuelslot).func_77973_b().func_77634_r()) // Fuel
																			// slot
				{
					func_70299_a(fuelslot,
							new ItemStack(func_70301_a(fuelslot).func_77973_b().func_77668_q()));
				} else if (func_70301_a(fuelslot).field_77994_a > 1)
				{
					func_70298_a(fuelslot, 1);
				} else if (func_70301_a(fuelslot).field_77994_a == 1)
				{
					func_70299_a(fuelslot, null);
				}
				updateInventory = true;
			}
		}
		if (isBurning() && canSmelt())
		{
			progress++;
			if (progress >= fuelScale)
			{
				progress = 0;
				cookItems();
				updateInventory = true;
			}
		} else
		{
			progress = 0;
		}
		if (burning != isBurning())
		{
			updateInventory = true;
		}
		if (updateInventory)
		{
			func_70296_d();
		}
	}

	public void cookItems()
	{
		if (this.canSmelt())
		{
			ItemStack itemstack = FurnaceRecipes.func_77602_a().func_151395_a(func_70301_a(input1));

			if (func_70301_a(output) == null)
			{
				func_70299_a(output, itemstack.func_77946_l());
			} else if (func_70301_a(output).func_77969_a(itemstack))
			{
				func_70301_a(output).field_77994_a += itemstack.field_77994_a;
			}
			if (func_70301_a(input1).field_77994_a > 1)
			{
				this.func_70298_a(input1, 1);
			} else
			{
				func_70299_a(input1, null);
			}
		}
	}

	public boolean canSmelt()
	{
		if (func_70301_a(input1) == null)
		{
			return false;
		} else
		{
			ItemStack itemstack = FurnaceRecipes.func_77602_a().func_151395_a(func_70301_a(input1));
			if (itemstack == null)
				return false;
			if (func_70301_a(output) == null)
				return true;
			if (!func_70301_a(output).func_77969_a(itemstack))
				return false;
			int result = func_70301_a(output).field_77994_a + itemstack.field_77994_a;
			return (result <= func_70297_j_() && result <= itemstack.func_77976_d());
		}
	}

	public boolean isBurning()
	{
		return fuel > 0;
	}

	public ItemStack getResultFor(ItemStack stack)
	{
		ItemStack result = FurnaceRecipes.func_77602_a().func_151395_a(stack);
		if (result != null)
		{
			return result.func_77946_l();
		}
		return null;
	}

	public void updateState()
	{
		IBlockState BlockStateContainer = field_145850_b.func_180495_p(field_174879_c);
		if (BlockStateContainer.func_177230_c() instanceof BlockMachineBase)
		{
			BlockMachineBase blockMachineBase = (BlockMachineBase) BlockStateContainer.func_177230_c();
			if (BlockStateContainer.func_177229_b(BlockMachineBase.ACTIVE) != fuel > 0)
				blockMachineBase.setActive(fuel > 0, field_145850_b, field_174879_c);
		}
	}

	@Override
	public Inventory getInventory() {
		return inventory;
	}
}
