package techreborn.tiles;

import reborncore.common.IWrenchable;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.Container;
import net.minecraft.inventory.InventoryCrafting;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.EnumFacing;
import reborncore.api.power.EnumPowerTier;
import reborncore.api.tile.IInventoryProvider;
import reborncore.common.powerSystem.TilePowerAcceptor;
import reborncore.common.util.Inventory;
import reborncore.common.util.ItemUtils;
import techreborn.api.RollingMachineRecipe;
import techreborn.init.ModBlocks;

//TODO add tick and power bars.
public class TileRollingMachine extends TilePowerAcceptor implements IWrenchable,IInventoryProvider
{

	public final InventoryCrafting craftMatrix = new InventoryCrafting(new RollingTileContainer(), 3, 3);
	public Inventory inventory = new Inventory(3, "TileRollingMachine", 64, this);
	public boolean isRunning;
	public int tickTime;
	public int runTime = 250;
	public ItemStack currentRecipe;

	public int euTick = 5;

	public TileRollingMachine()
	{
		super(1);
	}

	@Override
	public double getMaxPower()
	{
		return 100000;
	}

	@Override
	public boolean canAcceptEnergy(EnumFacing direction)
	{
		return true;
	}

	@Override
	public boolean canProvideEnergy(EnumFacing direction)
	{
		return false;
	}

	@Override
	public double getMaxOutput()
	{
		return 0;
	}

	@Override
	public double getMaxInput()
	{
		return 64;
	}

	@Override
	public EnumPowerTier getTier()
	{
		return EnumPowerTier.LOW;
	}

	@Override
	public void updateEntity()
	{
		super.updateEntity();
		charge(2);
		if (!field_145850_b.field_72995_K)
		{
			currentRecipe = RollingMachineRecipe.instance.findMatchingRecipe(craftMatrix, field_145850_b);
			if (currentRecipe != null && canMake())
			{
				if (tickTime >= runTime)
				{
					currentRecipe = RollingMachineRecipe.instance.findMatchingRecipe(craftMatrix, field_145850_b);
					if (currentRecipe != null)
					{
						boolean hasCrafted = false;
						if (inventory.func_70301_a(0) == null)
						{
							inventory.func_70299_a(0, currentRecipe);
							tickTime = -1;
							hasCrafted = true;
						} else
						{
							if (inventory.func_70301_a(0).field_77994_a + currentRecipe.field_77994_a <= currentRecipe
									.func_77976_d())
							{
								ItemStack stack = inventory.func_70301_a(0);
								stack.field_77994_a = stack.field_77994_a + currentRecipe.field_77994_a;
								inventory.func_70299_a(0, stack);
								tickTime = -1;
								hasCrafted = true;
							}
						}
						if (hasCrafted)
						{
							for (int i = 0; i < craftMatrix.func_70302_i_(); i++)
							{
								craftMatrix.func_70298_a(i, 1);
							}
							currentRecipe = null;
						}
					}
				}
			}
			if (currentRecipe != null)
			{
				if (canUseEnergy(euTick) && tickTime < runTime)
				{
					useEnergy(euTick);
					tickTime++;
				}
			}
			if (currentRecipe == null)
			{
				tickTime = -1;
			}
		} else
		{
			currentRecipe = RollingMachineRecipe.instance.findMatchingRecipe(craftMatrix, field_145850_b);
			if (currentRecipe != null)
			{
				inventory.func_70299_a(1, currentRecipe);
			} else
			{
				inventory.func_70299_a(1, null);
			}
		}
	}

	public boolean canMake()
	{
		return RollingMachineRecipe.instance.findMatchingRecipe(craftMatrix, field_145850_b) != null;
	}

	@Override
	public boolean wrenchCanSetFacing(EntityPlayer entityPlayer, EnumFacing side)
	{
		return false;
	}

	@Override
	public EnumFacing getFacing()
	{
		return getFacingEnum();
	}

	@Override
	public boolean wrenchCanRemove(EntityPlayer entityPlayer)
	{
		return entityPlayer.func_70093_af();
	}

	@Override
	public float getWrenchDropRate()
	{
		return 1.0F;
	}

	@Override
	public ItemStack getWrenchDrop(EntityPlayer entityPlayer)
	{
		return new ItemStack(ModBlocks.RollingMachine, 1);
	}

	@Override
	public void func_145839_a(NBTTagCompound tagCompound)
	{
		super.func_145839_a(tagCompound);
		ItemUtils.readInvFromNBT(craftMatrix, "Crafting", tagCompound);
		isRunning = tagCompound.func_74767_n("isRunning");
		tickTime = tagCompound.func_74762_e("tickTime");
	}

	@Override
	public void func_145841_b(NBTTagCompound tagCompound)
	{
		super.func_145841_b(tagCompound);
		ItemUtils.writeInvToNBT(craftMatrix, "Crafting", tagCompound);
		writeUpdateToNBT(tagCompound);
	}

	public void writeUpdateToNBT(NBTTagCompound tagCompound)
	{
		tagCompound.func_74757_a("isRunning", isRunning);
		tagCompound.func_74768_a("tickTime", tickTime);
	}

	@Override
	public void func_145843_s()
	{
		super.func_145843_s();
	}

	@Override
	public void onChunkUnload()
	{
		super.onChunkUnload();
	}

	@Override
	public Inventory getInventory() {
		return inventory;
	}

	private static class RollingTileContainer extends Container
	{

		@Override
		public boolean func_75145_c(EntityPlayer entityplayer)
		{
			return true;
		}

	}
}
